//===================================RISCKER====================================
//============================Arithmetic Shift Right============================
//------------------------------------------------------------------------------
//File Name: arithmetic_shift_rigth.v	
//Purpose:	Arithmetic Shift Right submodule for the "Operations" module
//Parameters:	w (data width) and s(shift amount size)
//------------------------------------------------------------------------------
//=====================Alfredo Gualdron - Jose P. Pinilla=======================
//=================================Semillero ADT================================
//================================UPB Bucaramanga===============================
//Website:	http://semilleroadt.upbbga.edu.co/xiscker
//E-mail:	semilleroadt@gmail.com
//------------------------------------------------------------------------------
module arithmetic_shift_rigth # (parameter w=16, s=4) (rin, rout, shamt);

	input [w-1:0] rin;
	output [w-1:0] rout;
	input [s-1:0] shamt;


genvar i;

generate 
		for (i=0; i<w; i=i+1)
				begin:Arithmetic_ShiftRight
					wire [w-1:0] path;
				
					assign path={{(w-1-i){rin[w-1]}},{rin[w-1:w-1-i]}};
				
				
					mux  mux_3	(.a(path), .y(rout[w-1-i]), .sh(shamt));
				end
		
endgenerate


endmodule

