//===================================RISCKER====================================
//=====================================PC=======================================
//------------------------------------------------------------------------------
//File Name:	program_counter.v
//Purpose:		Program counter source selection
//Parameters:	None
//------------------------------------------------------------------------------
//=====================Alfredo Gualdron - Jose P. Pinilla=======================
//=================================Semillero ADT================================
//================================UPB Bucaramanga===============================
//Website:	http://semilleroadt.upbbga.edu.co/xiscker
//E-mail:	semilleroadt@gmail.com
//------------------------------------------------------------------------------

module program_counter(
	input reset,
    input pc_next,										
    input [1:0] pc_src,									
    output reg[15:0] pc = 0,
	input [15:0] target, rd1, int_addr,
	output [15:0] pc_plus1								
    );

assign pc_plus1 = pc + 16'b1;
	
always @ (posedge pc_next or negedge reset)		//Next PC Source
	begin
	if (reset==0)
		pc <= 0;
	else
		case (pc_src)
			2'b00: pc <= pc_plus1;
			2'b01: pc <= target;
			2'b10: pc <= rd1;
			2'b11: pc <= int_addr;
			default: pc <= pc_plus1;
		endcase
	end
	


	
endmodule
